package com.chinaitop.depot.system.controller;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.chinaitop.depot.system.model.UserRole;
import com.chinaitop.depot.system.model.UserRoleExample;
import com.chinaitop.depot.system.model.UserRoleExample.Criteria;
import com.chinaitop.depot.system.service.UserRoleService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

/**
 * 用户角色控制类
 * @author xueenxi
 *
 */
@RestController
@RequestMapping(value="/userRole")
@Api(value= "UserRoleController", description = "人员角色控制类")
public class UserRoleController {
	
	@Resource
	private UserRoleService userRoleService;

	@RequestMapping(value="/getUserRole", method=RequestMethod.GET)
	@ApiOperation(value="查询一个用户的角色", notes = "查询一个用户的角色")
	@ApiImplicitParams({
		@ApiImplicitParam(name = "userId", value = "用户ID", paramType = "query")
	})
	public List<UserRole> getUserRole(Integer userId) {
		UserRoleExample example = new UserRoleExample();
		Criteria criteria = example.createCriteria();
		if (userId != null) {
			criteria.andUserIdEqualTo(userId);
		}
		return userRoleService.queryByExample(example);
	}

}
