package com.chinaitop.depot.system.service.impl;

import com.chinaitop.depot.system.mapper.RoleButtonMapper;
import com.chinaitop.depot.system.mapper.UserRoleMapper;
import com.chinaitop.depot.system.model.*;
import com.chinaitop.depot.system.service.RoleButtonService;
import com.chinaitop.depot.utils.RedisUtil;
import com.google.gson.Gson;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class RoleButtonServiceImpl implements RoleButtonService {
	
	@Resource
	private RoleButtonMapper roleButtonMapper;
	
	@Resource
	private UserRoleMapper userRoleMapper;

	@Autowired
	private RedisUtil redisUtil;

	@Override
	public List<RoleButton> queryByExample(RoleButtonExample example) {
		// TODO Auto-generated method stub
		return roleButtonMapper.selectByExample(example);
	}

	@Override
	public void save(Integer roleId, String[] btnIdList) {
		// TODO Auto-generated method stub
		RoleButtonExample example = new RoleButtonExample();
		example.createCriteria().andRoleIdEqualTo(roleId);
		roleButtonMapper.deleteByExample(example);
		// 批量新增
		if (btnIdList.length > 0) {
			List<RoleButton> list = new ArrayList<>();
			for (String btnId : btnIdList) {
				RoleButton roleButton = new RoleButton();
				roleButton.setRoleId(roleId);
				roleButton.setBtnId(Integer.parseInt(btnId));
				list.add(roleButton);
			}
			roleButtonMapper.batchInsert(list);
		}
	}
	
	@Override
	public void saveForList(Integer roleId, List<ButtonInfo> btnList) {
		// TODO Auto-generated method stub
		RoleButtonExample example = new RoleButtonExample();
		example.createCriteria().andRoleIdEqualTo(roleId);
		roleButtonMapper.deleteByExample(example);
		// 批量新增
		if (btnList.size() > 0) {
			List<RoleButton> list = new ArrayList<>();
			for (ButtonInfo btn : btnList) {
				RoleButton roleButton = new RoleButton();
				roleButton.setRoleId(roleId);
				roleButton.setBtnId(btn.getBtnId());
				list.add(roleButton);
			}
			roleButtonMapper.batchInsert(list);
		}
	}

	@Override
	public List<RoleButton> queryByUser(UserInfo userInfo) {
		UserRoleExample example = new UserRoleExample();
		example.createCriteria().andUserIdEqualTo(userInfo.getUserId());
		List<UserRole> urList = userRoleMapper.selectByExample(example);
		List<Integer> roleIds = new ArrayList<>();
		if(urList!=null){
			urList.forEach(ur -> roleIds.add(ur.getRoleId()));
		}
		Map<String, Object> param = new HashMap<String, Object>();
		Gson gson=new Gson();
		String jsonids = gson.toJson(roleIds);
		jsonids = jsonids.replace("[", "(");
		jsonids = jsonids.replace("]", ")");
		List<RoleButton> rbList = new ArrayList<RoleButton>();
		if(jsonids != null && jsonids.length() > 2) {
			param.put("roleIds", jsonids);
			rbList = roleButtonMapper.selectByExampleNew(param);
		}
		String json = gson.toJson(rbList);
		redisUtil.set("permissionList", json);
		return rbList;
	}

	@Override
	public void remove(Integer roleId) {
		RoleButtonExample example = new RoleButtonExample();
		example.createCriteria().andRoleIdEqualTo(roleId);
		roleButtonMapper.deleteByExample(example);
	}

}
